import{s as Te,o as be,n as Le}from"../chunks/scheduler.defa9a21.js";import{S as xe,i as He,g as l,s as o,r as K,m as ve,A as Me,h as i,f as a,c,j as ye,u as Q,x as d,n as ge,k as $e,y as Pe,a as r,v as V,d as Z,t as ee,w as te}from"../chunks/index.fe795e71.js";import{T as we}from"../chunks/Tip.179eb360.js";import{H as Ce,E as ke}from"../chunks/EditOnGithub.0f575778.js";function Ae(k){let n,h=`Synchronization of the main torch (or CUDA or XLA) random number generator will affect any other potential random
artifacts you could have in your dataset (like random data augmentation) in the sense that all processes will get
the same random numbers from the torch random modules (so will apply the same random data augmentation if it’s
controlled by torch).`;return{c(){n=l("p"),n.textContent=h},l(s){n=i(s,"P",{"data-svelte-h":!0}),d(n)!=="svelte-1pu9s3f"&&(n.textContent=h)},m(s,p){r(s,n,p)},p:Le,d(s){s&&a(n)}}}function De(k){let n,h=`The randomization part of your custom sampler, batch sampler or iterable dataset should be done using a local
<code>torch.Generator</code> object (in PyTorch &gt;= 1.6), see the traditional <code>RandomSampler</code>, as an example.`;return{c(){n=l("p"),n.innerHTML=h},l(s){n=i(s,"P",{"data-svelte-h":!0}),d(n)!=="svelte-1ffnyf3"&&(n.innerHTML=h)},m(s,p){r(s,n,p)},p:Le,d(s){s&&a(n)}}}function Se(k){let n,h,s,p,f,D,_,ae=`Internally, 🤗 Accelerate works by first analyzing the environment in which the script is launched to determine which
kind of distributed setup is used, how many different processes there are and which one the current script is in. All
that information is stored in the <code>~AcceleratorState</code>.`,S,v,re=`This class is initialized the first time you instantiate an <a href="/docs/accelerate/v0.34.1/en/package_reference/accelerator#accelerate.Accelerator">~Accelerator</a> as well as performing any
specific initialization your distributed setup needs. Its state is then uniquely shared through all instances of
<a href="/docs/accelerate/v0.34.1/en/package_reference/state#accelerate.state.AcceleratorState">AcceleratorState</a>. (The same can also be done with the <a href="/docs/accelerate/v0.34.1/en/package_reference/state#accelerate.PartialState">PartialState</a>, a more barebones version it inherits)`,z,y,ne='Then, when calling <a href="/docs/accelerate/v0.34.1/en/package_reference/accelerator#accelerate.Accelerator.prepare">prepare()</a>, the library:',q,g,le='<li>wraps your model(s) in the container adapted for the distributed setup,</li> <li>wraps your optimizer(s) in an <a href="/docs/accelerate/v0.34.1/en/package_reference/torch_wrappers#accelerate.optimizer.AcceleratedOptimizer">AcceleratedOptimizer</a>,</li> <li>wraps your scheduler(s) in an <a href="/docs/accelerate/v0.34.1/en/package_reference/torch_wrappers#accelerate.scheduler.AcceleratedScheduler">AcceleratedScheduler</a></li> <li>creates a new version of your dataloader(s) in a <a href="/docs/accelerate/v0.34.1/en/package_reference/torch_wrappers#accelerate.data_loader.DataLoaderShard">DataLoaderShard</a> or <a href="/docs/accelerate/v0.34.1/en/package_reference/torch_wrappers#accelerate.data_loader.DataLoaderDispatcher">DataLoaderDispatcher</a></li>',E,$,ie=`While the model(s), optimizer(s), and scheduler(s) are just put in simple wrappers, the dataloader(s) are re-created. This is mostly
because PyTorch does not let the user change the <code>batch_sampler</code> of a dataloader once it’s been created and the
library handles the sharding of your data between processes by changing that <code>batch_sampler</code> to yield every other
<code>num_processes</code> batches (if enabled).`,I,w,se='The <a href="/docs/accelerate/v0.34.1/en/package_reference/torch_wrappers#accelerate.data_loader.DataLoaderShard">DataLoaderShard</a> subclasses <code>DataLoader</code> to add the following functionality:',U,L,oe=`<li>it synchronizes the appropriate random number generator of all processes at each new iteration, to ensure any
randomization (like shuffling) is done the exact same way across processes.</li> <li>it puts the batches on the proper device before yielding them (unless you have opted out of
<code>device_placement=True</code>).</li>`,j,T,ce='The <a href="/docs/accelerate/v0.34.1/en/package_reference/torch_wrappers#accelerate.data_loader.DataLoaderDispatcher">DataLoaderDispatcher</a> subclasses differs from the <a href="/docs/accelerate/v0.34.1/en/package_reference/torch_wrappers#accelerate.data_loader.DataLoaderShard">DataLoaderShard</a> in that when iterating through the <code>DataLoader</code>, the data is all starting from process 0 and <em>then</em> split and sent off to each process rather than it happening at the dataset level.',N,b,de="The random number generator synchronization will by default synchronize:",O,x,he="<li>the <code>generator</code> attribute of a given sampler (like the PyTorch <code>RandomSampler</code>) for PyTorch &gt;= 1.6</li> <li>the main random number generator in PyTorch &lt;=1.5.1</li>",R,H,pe=`You can choose which random number generator(s) to synchronize with the <code>rng_types</code> argument of the main
<a href="/docs/accelerate/v0.34.1/en/package_reference/accelerator#accelerate.Accelerator">Accelerator</a>. In PyTorch &gt;= 1.6, it is recommended to rely on a local <code>generator</code> to avoid
setting the same seed in the main random number generator in all processes.`,G,m,F,u,W,M,me='If you have <a href="https://github.com/pytorch/data/tree/main" rel="nofollow"><code>torchdata&gt;=0.8.0</code></a> installed, and you have passed <code>use_stateful_dataloader=True</code> into your <a href="/docs/accelerate/v0.34.1/en/package_reference/utilities#accelerate.DataLoaderConfiguration">DataLoaderConfiguration</a>, these classes will directly inherit from <code>StatefulDataLoader</code> instead, and maintain a <code>state_dict</code>.',X,P,ue='For more details about the internals, see the <a href="package_reference/torch_wrappers">Internals page</a>.',Y,C,B,A,J;return f=new Ce({props:{title:"🤗 Accelerate’s internal mechanisms",local:"-accelerates-internal-mechanisms",headingTag:"h1"}}),m=new we({props:{warning:!0,$$slots:{default:[Ae]},$$scope:{ctx:k}}}),u=new we({props:{$$slots:{default:[De]},$$scope:{ctx:k}}}),C=new ke({props:{source:"https://github.com/huggingface/accelerate/blob/main/docs/source/concept_guides/internal_mechanism.md"}}),{c(){n=l("meta"),h=o(),s=l("p"),p=o(),K(f.$$.fragment),D=o(),_=l("p"),_.innerHTML=ae,S=o(),v=l("p"),v.innerHTML=re,z=o(),y=l("p"),y.innerHTML=ne,q=o(),g=l("ul"),g.innerHTML=le,E=o(),$=l("p"),$.innerHTML=ie,I=o(),w=l("p"),w.innerHTML=se,U=o(),L=l("ul"),L.innerHTML=oe,j=o(),T=l("p"),T.innerHTML=ce,N=o(),b=l("p"),b.textContent=de,O=o(),x=l("ul"),x.innerHTML=he,R=o(),H=l("p"),H.innerHTML=pe,G=o(),K(m.$$.fragment),F=o(),K(u.$$.fragment),W=ve(`
<Note>
`),M=l("p"),M.innerHTML=me,X=ve(`
</Note>
`),P=l("p"),P.innerHTML=ue,Y=o(),K(C.$$.fragment),B=o(),A=l("p"),this.h()},l(e){const t=Me("svelte-u9bgzb",document.head);n=i(t,"META",{name:!0,content:!0}),t.forEach(a),h=c(e),s=i(e,"P",{}),ye(s).forEach(a),p=c(e),Q(f.$$.fragment,e),D=c(e),_=i(e,"P",{"data-svelte-h":!0}),d(_)!=="svelte-13gim1o"&&(_.innerHTML=ae),S=c(e),v=i(e,"P",{"data-svelte-h":!0}),d(v)!=="svelte-1qph4x6"&&(v.innerHTML=re),z=c(e),y=i(e,"P",{"data-svelte-h":!0}),d(y)!=="svelte-1uk1h9u"&&(y.innerHTML=ne),q=c(e),g=i(e,"UL",{"data-svelte-h":!0}),d(g)!=="svelte-8rwpw1"&&(g.innerHTML=le),E=c(e),$=i(e,"P",{"data-svelte-h":!0}),d($)!=="svelte-1xlmls8"&&($.innerHTML=ie),I=c(e),w=i(e,"P",{"data-svelte-h":!0}),d(w)!=="svelte-2rq2qn"&&(w.innerHTML=se),U=c(e),L=i(e,"UL",{"data-svelte-h":!0}),d(L)!=="svelte-zg63ut"&&(L.innerHTML=oe),j=c(e),T=i(e,"P",{"data-svelte-h":!0}),d(T)!=="svelte-uc80ex"&&(T.innerHTML=ce),N=c(e),b=i(e,"P",{"data-svelte-h":!0}),d(b)!=="svelte-rp8jqi"&&(b.textContent=de),O=c(e),x=i(e,"UL",{"data-svelte-h":!0}),d(x)!=="svelte-1nv6po7"&&(x.innerHTML=he),R=c(e),H=i(e,"P",{"data-svelte-h":!0}),d(H)!=="svelte-pueyuy"&&(H.innerHTML=pe),G=c(e),Q(m.$$.fragment,e),F=c(e),Q(u.$$.fragment,e),W=ge(e,`
<Note>
`),M=i(e,"P",{"data-svelte-h":!0}),d(M)!=="svelte-19002d1"&&(M.innerHTML=me),X=ge(e,`
</Note>
`),P=i(e,"P",{"data-svelte-h":!0}),d(P)!=="svelte-1hmhnse"&&(P.innerHTML=ue),Y=c(e),Q(C.$$.fragment,e),B=c(e),A=i(e,"P",{}),ye(A).forEach(a),this.h()},h(){$e(n,"name","hf:doc:metadata"),$e(n,"content",ze)},m(e,t){Pe(document.head,n),r(e,h,t),r(e,s,t),r(e,p,t),V(f,e,t),r(e,D,t),r(e,_,t),r(e,S,t),r(e,v,t),r(e,z,t),r(e,y,t),r(e,q,t),r(e,g,t),r(e,E,t),r(e,$,t),r(e,I,t),r(e,w,t),r(e,U,t),r(e,L,t),r(e,j,t),r(e,T,t),r(e,N,t),r(e,b,t),r(e,O,t),r(e,x,t),r(e,R,t),r(e,H,t),r(e,G,t),V(m,e,t),r(e,F,t),V(u,e,t),r(e,W,t),r(e,M,t),r(e,X,t),r(e,P,t),r(e,Y,t),V(C,e,t),r(e,B,t),r(e,A,t),J=!0},p(e,[t]){const fe={};t&2&&(fe.$$scope={dirty:t,ctx:e}),m.$set(fe);const _e={};t&2&&(_e.$$scope={dirty:t,ctx:e}),u.$set(_e)},i(e){J||(Z(f.$$.fragment,e),Z(m.$$.fragment,e),Z(u.$$.fragment,e),Z(C.$$.fragment,e),J=!0)},o(e){ee(f.$$.fragment,e),ee(m.$$.fragment,e),ee(u.$$.fragment,e),ee(C.$$.fragment,e),J=!1},d(e){e&&(a(h),a(s),a(p),a(D),a(_),a(S),a(v),a(z),a(y),a(q),a(g),a(E),a($),a(I),a(w),a(U),a(L),a(j),a(T),a(N),a(b),a(O),a(x),a(R),a(H),a(G),a(F),a(W),a(M),a(X),a(P),a(Y),a(B),a(A)),a(n),te(f,e),te(m,e),te(u,e),te(C,e)}}}const ze='{"title":"🤗 Accelerate’s internal mechanisms","local":"-accelerates-internal-mechanisms","sections":[],"depth":1}';function qe(k){return be(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ne extends xe{constructor(n){super(),He(this,n,qe,Se,Te,{})}}export{Ne as component};
